<?php

 /**
 * Diese Datei enthält ein Beispiel-Skript zur Stornierung einer Inkasso-Forderung mit PHP.
 * Das Skript hat lediglich exemplarischen Charakter und dient keinesfalls als vollständige Funktions-Referenz!
 * Die SOAP-Funktionalität steht nur dann zur Verfügung, wenn PHP mit der Option --enable-soap konfiguriert wurde.
 */
 

//Lizenz-Schlüssel der Applikation:
$applicationLicence = 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx';

//Lizenz-Schlüssel des Mandanten:
$clientLicence = 'yyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy';

//Mandanten-ID:
$clientId = 1234;

//Aus Applikations-Lizenz und Mandanten-Lizenz den Lizenzschlüssel für die Autorisierung bilden:
$licenceKey = md5($applicationLicence . $clientLicence);

//Array für die Authentifizierung bauen:
$auth = array(
    'clientId'   => $clientId,
    'licenceKey' => $licenceKey,
    'sandbox'    => true); //TRUE = Testbetrieb, FALSE = Produktivbetrieb

//Optionen für das SoapClient-Objekt:
$options = array(
    'trace'       => 1,     //so können später u.a. die Methoden __getLastRequest() und __getLastResponse() aufgerufen werden
    'compression' => true,  //Daten werden komprimiert zum Server übertragen
    'exceptions'  => true); //SOAP-Faults werden als Exception weitergereicht


//Nach der Erstellung eines SoapClient-Objekts mittels WSDL-Dokument, stehen die vom Web-Service
//angebotenen Funktionen direkt als Methoden des Objektes zur Verfügung:
$soapClient = new SoapClient('https://soap.mediafinanz.de/encashment210.wsdl', $options);

//Array für Forderungs-Identifizierung bauen.
//Hierbei muss entweder 'fileNumber' (das von mediafinanz vergebene Aktenzeichen) oder
//'invoice' (die eindeutige Rechnungsnummer des Mandanten) angegeben werden:
$claimIdentifier = array('fileNumber' => '123456789');


try
{
    //Web-Service - Funktion zur Stornierung einer Forderung aufrufen:
    //Hinweis: mediafinanz erhebt für die Stornierung eines laufenden Verfahrens eine Kostenpauschale!
    //Falls Sie die Forderung aufgrund einer Direktzahlung des Schuldners einstellen möchten, übergeben Sie
    //bitte als dritten Parameter die Details der Direktzahlung (Typ DirectPayment)!
    $result = $soapClient->closeClaim($auth, $claimIdentifier);

    //Rückgabewert auswerten:
    if ($result)
    {
        echo "Die Forderung wurde erfolgreich storniert!<br />\n";
    }
    else
    {
    	echo "Die Forderung konnte nicht storniert werden!<br />\n";
    }
}
catch (Exception $e)
{
    echo "Es ist folgender Fehler aufgetreten: ".$e->getMessage() . "<br />\n";
}